package de.javabeginners.plugin.notice.ui.elements;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.IMessageProvider;
import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class NewListDataInputDialog extends TitleAreaDialog {

	private String title, message, value;
	private Text entryField;

	public NewListDataInputDialog(Shell parentShell, String title,
			String message) {
		super(parentShell);
		this.title = title;
		this.message = message;
	}

	@Override
	public void create() {
		super.create();
		setTitle(title);
		setMessage(message, IMessageProvider.INFORMATION);
	}

	@Override
	protected boolean isResizable() {
		return true;
	}

	@Override
	protected Control createDialogArea(Composite parent) {
		Composite area = (Composite) super.createDialogArea(parent);
		Composite container = new Composite(area, SWT.NONE);
		container.setLayoutData(new GridData(GridData.FILL_BOTH));
		GridLayout gridLayout = new GridLayout(2, false);
		container.setLayout(gridLayout);
		// rows
		GridData labelData, fieldData;
		Label label;

		labelData = new GridData();
		labelData.grabExcessHorizontalSpace = false;
		labelData.horizontalAlignment = GridData.FILL;
		labelData.horizontalSpan = 1;

		label = new Label(container, SWT.NONE);
		label.setText("Text");
		label.setLayoutData(labelData);

		fieldData = new GridData();
		fieldData.grabExcessHorizontalSpace = true;
		fieldData.horizontalAlignment = GridData.FILL;
		fieldData.horizontalSpan = 1;

		entryField = new Text(container, SWT.BORDER);
		entryField.setLayoutData(fieldData);

		return container;
	}

	@Override
	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setText(title);
	}

	public String getValue() {
		return value;
	}

	@Override
	protected void buttonPressed(int buttonId) {
		if (buttonId == IDialogConstants.OK_ID) {
			value = entryField.getText();
		} else {
			value = null;
		}
		super.buttonPressed(buttonId);
	}
}
