package de.javabeginners.plugin.notice.ui.elements;

import org.eclipse.jface.viewers.ISelectionProvider;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

/**
 * Superclass of all view types, such as text views, table views and list views.
 * 
 * @author Joerg Czeschla, javabeginners.de
 * 
 *
 */
public abstract class NoticeComposite extends Composite {

	public NoticeComposite(Composite parent, String id, int style) {
		super(parent, style);

		GridLayout gridLayout = new GridLayout(1, true);
		this.setLayout(gridLayout);
		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, true);
		gridData.widthHint = GridData.FILL_HORIZONTAL;
		gridData.heightHint = GridData.FILL_VERTICAL;
		this.setLayoutData(gridData);
	}

	public abstract Control getControl();

	public abstract Object getContents();

	public abstract void setContents(Object obj);

	public abstract ISelectionProvider getSelectionProvider();

	public abstract String getID();

	public String toString() {
		return this.getClass().getName();
	}

}
