package de.javabeginners.plugin.notice.ui.elements;

import org.eclipse.jface.dialogs.TitleAreaDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * Superclass of <code>RenameTabDialog</code> and <code>NewTabDialog</code>
 * derived from <code>org.eclipse.jface.dialogs.TitleAreaDialog</code>
 * 
 * @author Joerg Czeschla, javabeginners.de
 *
 */
public class TabDialog extends TitleAreaDialog {

	protected Text tabTitleText;

	private String tabTitleStr;

	protected Composite area, container;

	public TabDialog(Shell parent) {
		super(parent);
	}

	@Override
	public void create() {
		super.create();
	}

	@Override
	protected Control createDialogArea(Composite parent) {
		area = (Composite) super.createDialogArea(parent);
		container = new Composite(area, SWT.NONE);
		container.setLayoutData(new GridData(GridData.FILL_BOTH));
		GridLayout layout = new GridLayout(2, true);
		container.setLayout(layout);
		parent.getShell().setMinimumSize(200, 170);

		// tab title
		Label titleLabel = new Label(container, SWT.NONE);
		titleLabel.setText("Tab Title");
		GridData titleData = new GridData();
		titleData.grabExcessHorizontalSpace = true;
		titleData.horizontalAlignment = GridData.FILL;
		tabTitleText = new Text(container, SWT.BORDER);
		tabTitleText.setLayoutData(titleData);
		setHelpAvailable(false);
		return container;
	}

	@Override
	protected boolean isResizable() {
		return true;
	}

	@Override
	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setText("New Tab");
	}

	protected void saveInput() {
		tabTitleStr = tabTitleText.getText();
	}

	public String getTitle() {
		return tabTitleStr;
	}
}
